{-# LANGUAGE GADTs #-}
{-# LANGUAGE FunctionalDependencies #-}
module Functions where

import Sources

data Image = Image
  deriving (Show)
data ImageConversion = ImageConversion
  deriving (Show)

data Function a b where
  IsImageFilename :: Function FilePath Bool
  ConvertedImageFilename :: Function FilePath FilePath

deriving instance Show (Function a b)

data FunctionIO a b where
  ListDirectory :: FunctionIO FilePath [FilePath]
  OpenImage :: FunctionIO FilePath Image
  ConvertImage :: FunctionIO (Image, ImageConversion) Image
  Save :: FunctionIO (a, FilePath) ()
  RunPandoc :: FunctionIO String String

deriving instance Show (FunctionIO a b)



class (SourceState a, Show f) => IsFIO f a b | f -> a b where
  runFIO :: f -> a -> IO b


data ListDirectory' = ListDirectory'
  deriving (Show)
instance IsFIO ListDirectory' FilePath [FilePath] where
  runFIO ListDirectory' path = undefined

data OpenImage' = OpenImage'
  deriving (Show)
instance IsFIO OpenImage' FilePath Image where
  runFIO OpenImage' path = undefined
